<?php

/**
 * This file is part of the Nette Framework (http://nette.org)
 *
 * Copyright (c) 2004 David Grudl (http://davidgrudl.com)
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package Nette\Latte
 */



/**
 * Latte parser token.
 *
 * @author     David Grudl
 * @package Nette\Latte
 */
class LatteToken extends Object
{
	const TEXT = 'text',
		MACRO = 'macro',
		TAG_BEGIN = 'tag_begin',
		TAG_END = 'tag_end',
		ATTRIBUTE = 'attribute',
		COMMENT = 'comment';

	/** @var int */
	public $type;

	/** @var string */
	public $text;

	/** @var int */
	public $line;

	/** @var string  MACRO, TAG_BEGIN, ATTRIBUTE */
	public $name;

	/** @var string  MACRO, ATTRIBUTE */
	public $value;

	/** @var string  MACRO */
	public $modifiers;

	/** @var bool  TAG_BEGIN */
	public $closing;

}
