<?php

/**
 * Test: Presenter and checking params.
 *
 * @author     David Grudl
 * @package    Nette\Application\UI
 * @subpackage UnitTests
 */



require dirname(__FILE__) . '/../bootstrap.php';



class TestPresenter extends Presenter
{
	function actionDefault($a, $b = NULL, array $c, array $d = NULL, $e = 1, $f = 1.0, $g = FALSE)
	{
	}

}


$container = id(new Configurator)->setTempDirectory(TEMP_DIR)->createContainer();
$presenter = new TestPresenter($container);


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'action\' => array()));
	$presenter->run($request);
'), 'BadRequestException', 'Action name is not alphanumeric string.');


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'do\' => array()));
	$presenter->run($request);
'), 'BadRequestException', 'Signal name is not string.');


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'a\' => array()));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'a', expected scalar.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'b\' => array()));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'b', expected scalar.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'c\' => 1));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'c', expected array.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'d\' => 1));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'd', expected array.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'e\' => 1.1));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'e', expected integer.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'e\' => \'1 \'));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'e', expected integer.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'f\' => \'1 \'));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'f', expected double.");


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('presenter'=>$presenter)).'], EXTR_REFS);
	$request = new PresenterRequest(\'Test\', HttpRequest::GET, array(\'g\' => \'\'));
	$presenter->run($request);
'), 'BadRequestException', "Invalid value for parameter 'g', expected boolean.");
