<?php

/**
 * Test: LatteFilter and FormMacros.
 *
 * @author     David Grudl
 * @package    Nette\Latte
 * @subpackage UnitTests
 * @keepTrailingSpaces
 */



require dirname(__FILE__) . '/../bootstrap.php';

require dirname(__FILE__) . '/Template.inc';



TestHelpers::purge(TEMP_DIR);


$form = new Form;
$form->addText('username', 'Username:');
$form->addPassword('password', 'Password:');
$form->addSubmit('send', 'Sign in');

$template = new FileTemplate(dirname(__FILE__) . '/templates/forms.latte');
$template->registerFilter(new LatteFilter);
$template->_control = array('myForm' => $form);


$path = dirname(__FILE__) . '/expected/' . basename(__FILE__, '.phpt');
Assert::match(file_get_contents("$path.phtml"), codefix($template->compile()));
Assert::match(file_get_contents("$path.html"), $template->__toString(TRUE));
