<?php

/**
 * Test: LatteFilter: whitespace test II.
 *
 * @author     David Grudl
 * @package    Nette\Latte
 * @subpackage UnitTests
 */



require dirname(__FILE__) . '/../bootstrap.php';

require dirname(__FILE__) . '/Template.inc';



$template = new Template;
$template->registerFilter(new LatteFilter);

Assert::match(<<<EOD
qwerty

EOD

, (string) $template->setSource(<<<EOD
{* comment
*}
qwerty

EOD
));



Assert::match(<<<EOD
qwerty

EOD

, (string) $template->setSource(<<<EOD
{* comment
*}

qwerty

EOD
));



Assert::match(<<<EOD

qwerty

EOD

, (string) $template->setSource(<<<EOD
{* comment
*}


qwerty

EOD
));



Assert::match(<<<EOD
qwerty

EOD

, (string) $template->setSource(<<<EOD
{* comment
*}

{contentType text}
qwerty

EOD
));


Assert::match(<<<EOD
qwerty

EOD

, (string) $template->setSource(<<<EOD
{* comment
*}
{contentType text}
qwerty

EOD
));
