<?php

/**
 * Test: Strings and RegexpException run-time error.
 *
 * @author     David Grudl
 * @package    Nette\Utils
 * @subpackage UnitTests
 */



require dirname(__FILE__) . '/../bootstrap.php';



ini_set('pcre.backtrack_limit', 3); // forces PREG_BACKTRACK_LIMIT_ERROR

Assert::throws(create_function('', '
	Strings::split(\'0123456789\', \'#.*\\d#\');
'), 'RegexpException', 'Backtrack limit was exhausted (pattern: #.*\d#)');

Assert::throws(create_function('', '
	Strings::match(\'0123456789\', \'#.*\\d#\');
'), 'RegexpException', 'Backtrack limit was exhausted (pattern: #.*\d#)');

Assert::throws(create_function('', '
	Strings::matchAll(\'0123456789\', \'#.*\\d#\');
'), 'RegexpException', 'Backtrack limit was exhausted (pattern: #.*\d#)');

Assert::throws(create_function('', '
	Strings::replace(\'0123456789\', \'#.*\\d#\', \'x\');
'), 'RegexpException', 'Backtrack limit was exhausted (pattern: #.*\d#)');

function cb() { return 'x'; }

Assert::throws(create_function('', '
	Strings::replace(\'0123456789\', \'#.*\\d#\', callback(\'cb\'));
'), 'RegexpException', 'Backtrack limit was exhausted (pattern: #.*\d#)');
