<?php

/**
 * Test: Object event handlers.
 *
 * @author     David Grudl
 * @package    Nette
 * @subpackage UnitTests
 */



require dirname(__FILE__) . '/../bootstrap.php';

require dirname(__FILE__) . '/Object.inc';



function handler($obj)
{
	$obj->counter++;
}



class Handler
{
	function __invoke($obj)
	{
		$obj->counter++;
	}
}



$obj = new TestClass;
$var = (object) NULL;

$obj->onPublic[] = 'handler';

$obj->onPublic($var);
Assert::same( 1, $var->counter );



$obj->onPublic[] = new Handler;

$obj->onPublic($var);
Assert::same( 3, $var->counter );



Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('obj'=>$obj)).'], EXTR_REFS);
	$obj->onPrivate(123);
'), 'MemberAccessException', 'Call to undefined method TestClass::onPrivate().');


Assert::throws(create_function('', 'extract(NCFix::$vars['.NCFix::uses(array('obj'=>$obj)).'], EXTR_REFS);
	$obj->onUndefined(123);
'), 'MemberAccessException', 'Call to undefined method TestClass::onUndefined().');
